
function SHKSaveForm_getFormValues()
{
	var formValues = {};
	var allInputs = document.getElementsByTagName('input');
	
	for (var i = 0, max = allInputs.length; i < max; i++) 
	{
		var input = allInputs[i];
		var type = input.getAttribute('type');
		
		if (!type) {
			type = 'text'; // default is 'text''
		}
		
		var id = input.id;
		
		if (type == 'checkbox') 
		{
			formValues[id] = input.checked;				
		}
		else if (type == 'radio') 
		{
			formValues[id] = input.checked;
		}
		else if (type == 'password' || type == 'text' || type == 'email')
		{
			formValues[id] = input.value;
		}
		else if (type != 'hidden')
		{
			//alert('invalid type:' + type);
		}
	}
	
	var json = JSON.stringify(formValues);
	
	return json;
}

function SHKSaveForm_populateFormWithEncodedJSON(encodedJSON)
{
	var json = decodeURIComponent(encodedJSON);
	
	var formValues = JSON.parse(json);
		
	for (var prop in formValues) 
	{
		if (formValues.hasOwnProperty(prop))
		{
			var value = formValues[prop];
			var input = document.getElementById(prop);
			
			if (input.nodeName.toLowerCase() == 'input')
			{
				var type = input.getAttribute('type');
				
				if (!type) {
					type = 'text'; // default is 'text''
				}
				
				if (type == 'checkbox') 
				{
					input.checked = value;				
				}
				else if (type == 'radio') 
				{
					input.checked = value;
				}
				else if (type == 'password' || type == 'text' || type == 'email') 
				{
					input.value = value;
				}
				
			}
			else
			{
				//alert('invalid input:' + prop);
			}
		}

	}
}





