
if (typeof Thinkbitz === 'undefined') var Thinkbitz = {};

if (typeof Thinkbitz.FontSizeTools === 'undefined') Thinkbitz.FontSizeTools = new (function ()
{

	this.adjustFontSize = function(fontSize) {
		
		if (typeof Thinkbitz_FontSizeTools_adjustFontSize_custom !== 'undefined')
		{
			Thinkbitz_FontSizeTools_adjustFontSize_custom(fontSize);
		}
		else
		{
			var fontPercentage = "100%";
			
			if (fontSize < -1)
			{
				fontPercentage = "25%";
			}
			else if (fontSize < -1)
			{
				fontPercentage = "50%";
			}
			else if (fontSize == -1)
			{
				fontPercentage = "75%";
			}
			else if (fontSize > 0)
			{
				var percentage = 100 + fontSize * 50;
				
				fontPercentage = percentage + "%";
			}
			
			this.adjustFontSizeToPercent(fontPercentage);
			
		}
		
	}

	this.adjustFontSizeToPercent = function(size)
	{
		var cssCode = "body { -webkit-text-size-adjust:" + size + "; }";
		
		var style = document.getElementById('this.fontsize');
		
		if (size != "100%")
		{
			if (!style)
			{
				style = document.createElement('style');
				style.id = 'this.fontsize';
				document.head.appendChild(style);
			}
			
			style.innerHTML = cssCode;
		
			this.resetLineHeights();
		}
		else
		{
			document.head.removeChild(style);
		}
		
	}

	this.resetLineHeights = function()
	{
		this.resetLineHeightForElementsWithTag("p");   
		this.resetLineHeightForElementsWithTag("h1");   
		this.resetLineHeightForElementsWithTag("h2");   
		this.resetLineHeightForElementsWithTag("h3");   
		this.resetLineHeightForElementsWithTag("h4");   
		this.resetLineHeightForElementsWithTag("h5");   
		this.resetLineHeightForElementsWithTag("div");   
		this.resetLineHeightForElementsWithTag("li");   
		this.resetLineHeightForElementsWithTag("td");   
		this.resetLineHeightForElementsWithTag("a"); 	
	}

	this.resetLineHeightForElementsWithTag = function(tag)
	{
		var elements = document.getElementsByTagName(tag);   
		for (var i = 0; i < elements.length; i++) {   
			elements[i].style.lineHeight = "normal";
		} 
	}
	
})();