
if (typeof Thinkbitz === 'undefined') var Thinkbitz = {};

if (typeof Thinkbitz.ScrollTools === 'undefined') Thinkbitz.ScrollTools = new (function ()
{
	this.previousFrameTime = '';
	this.target = scrollY - window.innerHeight + 50;
	this.scrollUp = false;
	this.conversionY = 1;
	this.failedAttemptCount = 0;

	this.start = function(scrollUp, adjustment, webViewHeight) {
	
		this.scrollUp = scrollUp;
		
		this.conversionY = window.innerHeight / webViewHeight;
		
		var convertedAdjustment = (this.conversionY * adjustment);
		
		var divs=document.getElementsByTagName('div');
		
		var headers = document.getElementsByTagName('header');
		if (headers.length)
		{
			// Array.prototype.slice.call to concert from NodeLists to Arrays.
			divs = Array.prototype.slice.call(divs).concat( Array.prototype.slice.call(headers));
		}
		
		for (var i=0;i<divs.length;i++){
			
			var div = divs[i];
			var divStyle = window.getComputedStyle(div);
					
			if (divStyle.position == 'fixed')
			{
				var height = div.offsetHeight;
				
				// if it's more, assume it's a sidebar or something. (100 is an arbitrary value, typical size is around 40.)
				if (height < 100 && divStyle.visibility != "hidden" && divStyle.display != "none")
				{
					convertedAdjustment = convertedAdjustment + height;
				}
			}
		}
		
		if (scrollUp)
		{
			this.target = scrollY - window.innerHeight + 16 + convertedAdjustment;
		}
		else
		{
			this.target = scrollY + window.innerHeight - 16 - convertedAdjustment;
		}
		
		if (!scrollUp && (scrollY + window.innerHeight) == document.body.scrollHeight)
		{
			return false;
		}
		else if (scrollUp && scrollY == 0)
		{
			return false;
		}
		else
		{
			this.failedAttemptCount = 0;
		
			this.doScroll();
			
			return true;
		}
		
		
	}

	this.doScroll = function() {
		
		var skipAnimation = false;
		
		if (this.previousFrameTime != '')
		{
			msSinceLast = (new Date().getTime())-this.previousFrameTime;
			
			if (msSinceLast > 20)
			{
				// page is slowing down animation, let's just jump to the appropriate spot
				skipAnimation = true;
			}
		}
		
		if (skipAnimation)
		{
			window.scrollTo(scrollX, this.target); 
		}
		else
		{
			var previousScrollY = scrollY;
			this.previousFrameTime = (new Date().getTime());	
			
			var increment = 100 * this.conversionY;
			var needsMoreScrolling;
			if (this.scrollUp)
			{
				var target = scrollY - increment;
				if (target < this.target) target = this.target;

				window.scrollTo(scrollX, target);
				
				needsMoreScrolling = scrollY > this.target;
			}
			else
			{
				var target = scrollY + increment;
				if (target > this.target) target = this.target;
				
				window.scrollTo(scrollX, target);
				
				needsMoreScrolling = scrollY < this.target;
			}
			
			if (needsMoreScrolling)
			{
				var tryAgain = false;
			
				if (previousScrollY != scrollY)
				{
					tryAgain = true;
				}
				
				if (previousScrollY == scrollY && this.failedAttemptCount < 3)
				{
					tryAgain = true;
					this.failedAttemptCount++;
				}
							
				if (tryAgain)
				{
					var that = this;
					window.setTimeout( function() { that.doScroll(); } ,5);
				}
			}
		}
	};

})();